VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "class_agent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'This software comes with ABSOLUTELY NO WARRANTY. This is a free software under GNU GPL licence.
'Created by Jacquelin POTIER jacquelin.potier@libertysurf.fr
'ie reader 2002

Option Explicit
Private Const BalloonOn = 1
Private WithEvents ctl_agent As Agent
Attribute ctl_agent.VB_VarHelpID = -1

Public obj_char_ex As IAgentCtlCharacterEx
Private hide_request As IAgentCtlRequest
Private agent_unloaded As Boolean
Private unload_agent_key As String

Public chrtag As String 'Sets the character of the voice
                        '"Normal"    (Default) A normal tone of voice.
                        '"Monotone"    A monotone voice.
                        '"Whisper"    A whispered voice.
Public ctxtag As String 'Sets the context of the output text
                        '"Address"    Addresses and/or phone numbers.
                        '"E-mail"    Electronic mail.
                        '"Unknown"    (Default) Context is unknown.
Public pittag As Long 'Sets the baseline pitch of the output to the specified value in hertz
                      '50 <pit <250
Public spdtag As Long 'Sets the baseline average talking speed of the speech output,in words per minute
                      '50<speed<250
                 

Private Sub Class_Initialize()
    Set ctl_agent = New Agent
    Set hide_request = Nothing
End Sub

Private Sub Class_Terminate()
    unload_agent
    Set obj_char_ex = Nothing
    Set ctl_agent = Nothing
End Sub
                 
Public Function load_agent(agent_name As String, agent_folder As String, Optional key_agent As String = "unique_agent") As IAgentCtlCharacterEx
    On Error GoTo label_error
   'Load the character animation data file from the default folder.
   If Right$(agent_folder, 1) <> "\" Then agent_folder = agent_folder & "\"
   ctl_agent.Characters.Load key_agent, agent_folder & agent_name & ".acs"
   'Set the object variable for the character.
   Set obj_char_ex = ctl_agent.Characters(key_agent)
   'obj_char_ex.Show
   ctl_agent.Characters(key_agent).Show
      
   'add pop up menu cmd
   add_popupmenu
      
   'animations
    play "Greet"
    play "Pleased"
    
    Set load_agent = obj_char_ex
    agent_unloaded = False
    Exit Function
label_error:
    If Err = -2147024894 Then
        MsgBox Error$ & vbCrLf & "Choose another agent file in Agent Options", vbCritical
    Else
        MsgBox Error$, vbExclamation
    End If
    Exit Function
End Function

Public Function play(animation As String) As IAgentCtlRequest
    'avoid error if agent has not the corresponding animation (return nothing in this case)
    On Error Resume Next
    Set play = obj_char_ex.play(animation)
End Function

Public Sub unload_agent(Optional key_agent As String = "unique_agent")
    On Error Resume Next
    obj_char_ex.Stop
    unload_agent_key = key_agent
    Set hide_request = play("hide")
    'see the following action in request completed
    If hide_request Is Nothing Then real_unload_agent 'error: hide animation not done, so we force agent to be unloaded
    Do While Not agent_unloaded
        DoEvents
    Loop
End Sub

Public Sub show_ballon()
    On Error Resume Next
   ' Turn the word balloon on
   obj_char_ex.Balloon.Style = obj_char_ex.Balloon.Style Or BalloonOn

   'style: An integer that represents the balloon's output style. The style setting is a bit field with bits corresponding to: balloon-on (bit 0), size-to-text (bit 1), auto-hide (bit 2), auto-pace (bit 3), number of characters per lines (bits 16-23), and number of lines (bits 24-31).
   'think: ballon only ex: 'obj_char_ex.Think "ballon only"
End Sub

Public Sub hide_ballon()
    On Error Resume Next
   obj_char_ex.Balloon.Style = obj_char_ex.Balloon.Style And (Not BalloonOn) '254 '
   'obj_char_ex.Speak "No balloon"
   
   'style: An integer that represents the balloon's output style. The style setting is a bit field with bits corresponding to: balloon-on (bit 0), size-to-text (bit 1), auto-hide (bit 2), auto-pace (bit 3), number of characters per lines (bits 16-23), and number of lines (bits 24-31).
   'think: ballon only ex: 'obj_char_ex.Think "ballon only"
End Sub

Public Sub change_tts_engine(tts_engine_id As String)
    On Error GoTo label_error
    obj_char_ex.TTSModeID = tts_engine_id
    Exit Sub
label_error:
    If Err = -2147213293 Then
        MsgBox Error$ & vbCrLf & "Please download it at http://www.microsoft.com/msagent/downloads.htm", vbExclamation
    End If
    Resume Next
End Sub

Public Sub change_language(languageID As Long)
    On Error GoTo label_error
    obj_char_ex.languageID = languageID
    Exit Sub
label_error:
    If Err = -2147213294 Then
        MsgBox Error$ & vbCrLf & "Please download it at http://www.microsoft.com/msagent/downloads.htm", vbExclamation
    End If
    Resume Next
End Sub


Public Sub fill_voice_character_combobox(combo As ComboBox)
    combo.clear
    'combo.Style = vbComboDropdownList
    combo.AddItem "Normal"
    combo.AddItem "Monotone"
    combo.AddItem "Whisper"
    combo.ListIndex = 0
End Sub

Public Sub fill_voice_context_combobox(combo As ComboBox)
    combo.clear
    'combo.Style = vbComboDropdownList
    combo.AddItem "Address"
    combo.AddItem "E-mail"
    combo.AddItem "Unknown"
    combo.ListIndex = 0
End Sub

Public Sub fill_agent_combobox(combo As ComboBox, agent_folder As String)
    On Error Resume Next
    Dim agent_exist As Boolean
    Dim agent_name  As String
    combo.clear
    If Right$(agent_folder, 1) <> "\" Then agent_folder = agent_folder & "\"
    'combo.Style = vbComboDropdownList
    agent_name = Dir$(agent_folder & "*.acs")
    If agent_name <> "" Then
        agent_exist = True
    End If
    Do While agent_name <> ""
        combo.AddItem Left$(agent_name, InStr(1, agent_name, ".acs") - 1)
        agent_name = Dir$
    Loop
    If agent_exist Then combo.ListIndex = 0
End Sub

Public Sub speak(ByVal text As String)
    On Error Resume Next
    obj_char_ex.Show 'agent doesn't speak if it is hidden
    If obj_char_ex Is Nothing Then Exit Sub
    If Not agent_options.default_voice Then
        If pittag > 0 Then text = "\pit=" & pittag & "\" & text
        If spdtag > 0 Then text = "\spd=" & spdtag & "\" & text
        text = "\chr=" & chrtag & "\" & text
        text = "\ctx=" & ctxtag & "\" & text
    End If
    obj_char_ex.speak text
End Sub

Private Sub ctl_agent_RequestComplete(ByVal Request As Object)
    If Request = hide_request Then
        real_unload_agent
    End If
End Sub

Private Sub real_unload_agent()
    On Error Resume Next
    ctl_agent.Characters.Unload unload_agent_key
    Set obj_char_ex = Nothing
    Set hide_request = Nothing
    agent_unloaded = True
End Sub

Private Sub ctl_agent_DblClick(ByVal CharacterID As String, ByVal Button As Integer, ByVal Shift As Integer, ByVal x As Integer, ByVal y As Integer)
    On Error Resume Next
    obj_char_ex.Stop
    obj_ie.read_last_selected_web_page
End Sub

'''''''''''''''''''''''''''''''''
' adding menu
Private Sub add_popupmenu()
    On Error Resume Next
    obj_char_ex.Commands.RemoveAll
    obj_char_ex.Commands.add "read_webpage", "&Read web page"
    obj_char_ex.Commands.add "read_clipboard", "R&ead Clipboard"
    obj_char_ex.Commands.add "new_ie", "&New IE window"
    obj_char_ex.Commands.add "agent_options", "&Character agent options"
    obj_char_ex.Commands.add "webpage_options", "&Web page options"
    obj_char_ex.Commands.add "about", "&About"
End Sub

Private Sub ctl_agent_Command(ByVal UserInput As Object)
    On Error Resume Next
    Select Case UserInput.name
        Case "read_webpage"
            obj_char_ex.Stop
            obj_ie.read_last_selected_web_page
        Case "read_clipboard"
            obj_char_ex.Stop
            speak Clipboard.GetText()
        Case "new_ie"
            obj_ie.show_new_ie_window
        Case "agent_options"
            form_agent_config.my_show
        Case "webpage_options"
            form_webpage_options.myshow
        Case "about"
            MsgBox "This software comes with ABSOLUTELY NO WARRANTY." & vbCrLf & _
                   "This is a free software under GNU GPL licence." & vbCrLf & _
                   "Created by Jacquelin POTIER jacquelin.potier@libertysurf.fr" & vbCrLf & _
                   "IE reader 2002", vbInformation, "About"
    End Select
End Sub
