VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "class_internet_explorer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'This software comes with ABSOLUTELY NO WARRANTY. This is a free software under GNU GPL licence.
'Created by Jacquelin POTIER jacquelin.potier@libertysurf.fr
'ie reader 2002

Option Explicit

Private WithEvents ies As class_col_ie_event
Attribute ies.VB_VarHelpID = -1

Private Const waiting_animation = "Processing"
Private Const waiting_animation_return = "Read"

Private Sub Class_Initialize()
    Set ies = New class_col_ie_event
    show_new_ie_window
End Sub

Public Sub show_new_ie_window()
    ies.add New SHDocVw.InternetExplorer, False
End Sub

Private Sub Class_Terminate()
    Set ies = Nothing
End Sub


Private Sub ies_Documentonmouseover(objHTMLDocument As MSHTML.HTMLDocument)
    On Error Resume Next
    Dim tag_name As String
    Dim text     As String
    tag_name = UCase$(objHTMLDocument.parentWindow.event.srcElement.tagName)
    

'Debug.Print tag_name
  
    Select Case tag_name
    Case "A"
        If Not ie_options.read_a_tag Then Exit Sub
        text = ie_options.txt_before_link & ":" & objHTMLDocument.parentWindow.event.srcElement.innerText
    Case "IMG"
        If Not ie_options.read_img_tag Then Exit Sub
        If objHTMLDocument.parentWindow.event.srcElement.alt = "" Then Exit Sub
        text = ie_options.txt_before_image_tag & ":" & objHTMLDocument.parentWindow.event.srcElement.alt
    Case "INPUT"
        If Not ie_options.read_input_tag Then Exit Sub
        Select Case UCase$(objHTMLDocument.parentWindow.event.srcElement.Type)
        Case "IMAGE"
            text = ie_options.txt_before_button & ":" & objHTMLDocument.parentWindow.event.srcElement.alt
        Case "SUBMIT"
            text = ie_options.txt_before_button & ":" & objHTMLDocument.parentWindow.event.srcElement.value
        Case "TEXT", "TEXTAREA"
            text = ie_options.txt_before_text_input & ":" & objHTMLDocument.parentWindow.event.srcElement.value
        Case "CHECKBOX"
            text = ie_options.txt_before_checkbox '& ":" & objHTMLDocument.parentWindow.event.srcElement.value
        Case "PASSWORD"
            text = ie_options.txt_before_password & ":" & objHTMLDocument.parentWindow.event.srcElement.value
        Case "RADIO"
            text = ie_options.txt_before_radio '& ":" & objHTMLDocument.parentWindow.event.srcElement.value
        End Select
    Case "SELECT"
        If Not ie_options.read_select_tag Then Exit Sub
        text = ie_options.txt_before_select_tag & ":" & objHTMLDocument.parentWindow.event.srcElement.innerText
    Case "OPTION"
        If Not ie_options.read_option_tag Then Exit Sub
        text = ie_options.txt_before_option_tag & ":" & objHTMLDocument.parentWindow.event.srcElement.innerText
    Case "P"
        If Not ie_options.read_p_tag Then Exit Sub
        text = objHTMLDocument.parentWindow.event.srcElement.innerText
    Case "SPAN"
        If Not ie_options.read_span_tag Then Exit Sub
        text = objHTMLDocument.parentWindow.event.srcElement.innerText
    Case "DIV"
        If Not ie_options.read_div_tag Then Exit Sub
        text = objHTMLDocument.parentWindow.event.srcElement.innerText
    Case "FONT"
        If Not ie_options.read_font_tag Then Exit Sub
        text = objHTMLDocument.parentWindow.event.srcElement.innerText
    Case "TD"
        If Not ie_options.read_td_tag Then Exit Sub
        text = objHTMLDocument.parentWindow.event.srcElement.innerText
    End Select
   
    If text <> "" Then
        'stop reading only if wanted and there's something to say
        If ie_options.stop_agent_action_when_new_event Then
            obj_agent.obj_char_ex.Stop
        End If
        obj_agent.speak text
    End If
End Sub

Private Sub ies_BeforeNavigate2(iee As class_ie_event, is_oldest_ie_window As Boolean, pDisp As Object, URL As Variant, Flags As Variant, TargetFrameName As Variant, PostData As Variant, Headers As Variant, Cancel As Boolean)
    On Error Resume Next
    iee.docs.clear
    
    If is_oldest_ie_window Then obj_agent.play waiting_animation
    'animation and autoread are available only for the oldest ie window to avoid mix
End Sub

Private Sub ies_DocumentComplete(iee As class_ie_event, is_oldest_ie_window As Boolean, pDisp As Object, URL As Variant)
    On Error Resume Next
    If pDisp.document Is Nothing Then Exit Sub
    If pDisp.document.body.nodeName <> "FRAMESET" Then 'event seems not be thrown if we let the frameset document
        iee.docs.add pDisp.document
'Else
'    Debug.Print "frameset"
    End If
    
    If is_oldest_ie_window Then
    'animation and autoread are available only for the oldest ie window to avoid mix
        If pDisp Is iee.ie Then 'the entire page is loaded (all frames as been loaded) there's one panel display for each frame
            'MsgBox "Document is ready"
            obj_agent.obj_char_ex.Stop 'used in case of looping animations for waiting
            obj_agent.play waiting_animation_return
            
            If ie_options.auto_read_when_doc_completed Then
                obj_agent.speak iee.docs.get_inner_text()
            End If
        End If
    End If
End Sub

Public Sub read_last_selected_web_page()
    On Error Resume Next
    Dim iee As class_ie_event
    Dim text As String
    Set iee = ies.get_top_most_ie()
    If iee Is Nothing Then Exit Sub
    text = iee.docs.get_inner_text()
    If text <> "" Then
        'stop reading only if wanted and there's something to say
        If ie_options.stop_agent_action_when_new_event Then
            obj_agent.obj_char_ex.Stop
        End If
        obj_agent.speak text
    End If
    Set iee = Nothing
End Sub
